config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  
  root to: "users#index"

  resources :users, only: [:index, :show] do
    resources :posts, only: [:index, :show, :new, :create] do
      resources :likes, only: [:new, :create]
    end
  end
  resources :posts do
    resources :comments, only: [:new, :create]
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :user
  belongs_to :post

  validates :text, presence: true

  after_create :increment_post_comments_counter

  private

  def increment_post_comments_counter
    post.update(comments_counter: post.comments.count)
  end
end

app/models/like.rb
class Like < ApplicationRecord
  belongs_to :user
  belongs_to :post

  validates :user_id, uniqueness: { scope: :post_id, message: 'can only like a post once' }

  after_create :increment_post_likes_counter

  private

  def increment_post_likes_counter
    post.update(likes_counter: post.likes.count)
  end
end

app/models/post.rb
class Post < ApplicationRecord
  belongs_to :author, class_name: 'User'
  has_many :comments, dependent: :destroy
  has_many :likes, dependent: :destroy

  validates :title, presence: true, length: { maximum: 250 }
  validates :comments_counter, numericality: { greater_than_or_equal_to: 0, only_integer: true }
  validates :likes_counter, numericality: { greater_than_or_equal_to: 0, only_integer: true }

  after_create :increment_user_posts_counter

  def recent_comments
    comments.order(created_at: :desc).limit(5)
  end

  private

  def increment_user_posts_counter
    author.update(posts_counter: author.posts.count)
  end
end

app/models/user.rb
class User < ApplicationRecord
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :confirmable

  has_many :posts, foreign_key: 'author_id', dependent: :destroy
  has_many :comments, dependent: :destroy
  has_many :likes, dependent: :destroy

  validates :name, presence: true
  validates :posts_counter, numericality: { only_integer: true, greater_than_or_equal_to: 0 }
  validates :password, confirmation: true, length: { minimum: 8 }

  def recent_posts
    posts.order(created_at: :desc).limit(3)
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :authenticate_user!
  before_action :configure_permitted_parameters, if: :devise_controller?

  private

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: %i[name photo bio])
  end
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  def new
    @user = current_user
    @post = Post.find(params[:post_id])
    @comment = @post.comments.new
  end

  def create
    @post = Post.find(params[:post_id])
    @comment = @post.comments.new(comment_params)
    @comment.user = current_user
    respond_to do |format|
      if @comment.save
        format.html do
          redirect_to user_post_path(@post.author, @post), notice: 'Comment was successfully created.'
        end
      else
        format.html { render :new }
      end
    end
  end

  private

  def comment_params
    params.require(:comment).permit(:text)
  end
end

app/controllers/likes_controller.rb
class LikesController < ApplicationController
  def create
    @like = Like.new(like_params)
    respond_to do |format|
      format.html { redirect_to request.referer } if @like.save
    end
  end

  def like_params
    params.permit(:user_id, :post_id)
  end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  def index
    @user = User.find(request.params['user_id'])
  end

  def show
    @post = Post.find(request.params['id'])
  end

  def new
    @user = current_user
    @post = @user.posts.new
  end

  def create
    @user = current_user
    @post = @user.posts.build(post_params)

    if @post.save
      redirect_to user_posts_path(@user), flash: { notice: 'Post was successfully created.' }
    else
      render :new
    end
  end

  private

  def post_params
    params.require(:post).permit(:title, :text)
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  layout 'application'
  def index
    @users = User.all
  end

  def show
    @user = User.find(request.params['id'])
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/comments/_comment.html.erb
<p><%= comment.user.name %>: <%= comment.text.truncate(40, separator: '...') %> </p>

app/views/comments/new.html.erb
<div class="container my--16">
  <div class="row">
    <div class="col-12">
      <h2 class="post__title">Add A New Comments</h2>
    </div>
    <div class="col-12">
      <%= form_with(model: [@post, @comment]) do |f| %>
        <div class="form-group">
          <%= f.label :Description %>
          <%= f.text_area :text, class: "form-control" %>
        </div>
        <div class="form-group">
          <%= f.submit "Create Comments", class: "btn btn--primary", data: { disable_with: false }  %>
        </div>
      <% end %>
    </div>
  </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>BlogApp</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css" integrity="sha512-iecdLmaskl7CVkqkXNQ/ZH/XLlvWZOJyj7Yy7tcenmpD1ypASozpmT/E0iPtmFIB46ZmdtAc9eNBvH0H/ZpiBw==" crossorigin="anonymous" referrerpolicy="no-referrer" />
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <p class="notice"><%= notice %></p>
    <p class="alert"><%= alert %></p>
    <div class="modal-overlay">
      <div class="modal">
        <div class="modal-content">
          <h2>Flash Message</h2>
          <p class="flash-message"></p>
          <button class="close-modal">Close</button>
        </div>
      </div>
    </div>
    <%= yield %>
  </body>
</html>

app/views/posts/_post.html.erb
<div class="col-12 p-16 post">
        <h3 class="post__title"><%= link_to_unless_current post.title, user_post_path(@user, post), class:"post__title-link"%> #<%= post.id %></h3>
        <div class="post__description"><%= post.text.truncate(80, separator: '...') %> </div>
        <div class="post__extra">Comments: <%= post.comments_counter %>, Likes: <%= post.likes_counter %></div>
</div>

app/views/posts/index.html.erb
<div class="container my--16">
  <div class="row">
    <%= render @user %>
  </div>
  <div class="row user__posts">
    <div class="col-6">
      <h3 class="post__list-title">All Posts</h3>
    </div>
    <div class="col-6">
      <div class="post__btn-wrapper-r">
        <button class="btn btn--primary btn__add-new" >Add New Post</button>
      </div>
    </div>
    <% if @user.posts.empty? %>
     <div class="col-12 p-16 user__post">
        <p>No post found!</p>
      </div>
    <% else %>
    <% @user.posts.each do |post| %>
          <%= render post %>
            <% if post.recent_comments.empty? %>
              <div class="col-12 p-16 user__post">
                <p>No comment found!</p>
              </div>
            <% else %>
              <div class="col-12 post__comments p-16">
                  <% post.recent_comments.includes([:user]).each do |comment| %>
                    <%= render comment %>
                  <% end %>
              </div>
            <% end %>
        <% end %>
         <div class="col-12 post__btn-wrapper">
         <%= link_to "Pagination", user_posts_path(@user), class: "btn btn--primary" %>
         </div>
    <% end %>
  </div>
</div>

<script>
  var button = document.querySelector('.btn__add-new');

  button.addEventListener('click', function() {
    window.location.href = '<%= new_user_post_path(@user) %>';
  });
</script>

<script>
  const modalOverlay = document.querySelector('.modal-overlay');
  const flashMessage = document.querySelector('.flash-message');
  const closeModalButton = document.querySelector('.close-modal');

  <% if flash[:notice].present? %>
      flashMessage.innerText = '<%= flash[:notice] %>';
      modalOverlay.style.display = 'block';
  <% end %>

  closeModalButton.addEventListener('click', () => {
    modalOverlay.style.display = 'none';
  });
</script>

app/views/posts/new.html.erb
<div class="container my--16">
  <div class="row">
    <div class="col-12">
      <h2 class="post__title">Add A New Post</h2>
    </div>
    <div class="col-12">
      <%= form_with(model: [@user, @post]) do |f| %>
        <% if @post.errors[:title].any? %>
          <ul class="error_messages">
            <% @post.errors[:title].each do |message| %>
              <li><%= message %></li>
            <% end %>
          </ul>
        <% end %>
        <div class="form-group">
          <%= f.label :Title %>
          <%= f.text_field :title, class: "form-control" ,require:true %>
        </div>
        <div class="form-group">
          <%= f.label :Description %>
          <%= f.text_area :text, class: "form-control" %>
        </div>
        <div class="form-group">
          <%= f.submit "Create Post", class: "btn btn--primary" %>
        </div>
      <% end %>
    </div>
  </div>
</div>

app/views/posts/show.html.erb
<div class="container my--16">
  <div class="row post p-16 my--16">
    <div class="col-6">
      <div class="post__title"><%= @post.title %> #<%= @post.id %> by <%= @post.author.name %> </div>
    </div>
    <div class="col-6">
      <div class="post__extra">Comments: <%= @post.comments_counter %>, Likes: <%= @post.likes_counter %></div>
    </div>
    <div class="col-12">
      <%= @post.text %>
    </div>
  </div>

  <div class="row">
   <% if @post.comments.empty? %>
     <div class="col-12 p-16 user__post">
        <p>No comment found!</p>
      </div>
    <% else %>
    <div class="col-12 post__comments p-16">
    <% @post.comments.includes(:user).each do |comment| %>
        <%= render comment %>
      <% end %>
    </div>
    <% end %>
  </div>

  <div class="row my--16">
    <div class="col-12" style="display: flex; gap: 16px;">
      <% if (current_user && @post.likes.exists?(user_id: current_user.id)) %>
        <button class= 'btn btn--disabled' disabled="disabled" ><i class="fa-solid fa-thumbs-up"></i> Like</button>
      <% else %>
        <%= button_to user_post_likes_path(@user =current_user, @post), method: :post, class: 'btn btn--primary' do %>
          <i class="fa-solid fa-thumbs-up"></i> Like
        <% end %>
      <% end %> 
      <button id="add-new-comment" class="btn btn--primary" ><i class="fa-solid fa-comment"></i> Add comment</button>
    </div>
  </div>
</div>


<script>
  const btnComment = document.querySelector('#add-new-comment');

  btnComment.addEventListener('click', function() {
    window.location.href = '<%= new_post_comment_path(@post) %>';
  });
</script>

<script>
  const modalOverlay = document.querySelector('.modal-overlay');
  const flashMessage = document.querySelector('.flash-message');
  const closeModalButton = document.querySelector('.close-modal');

  <% if flash[:notice].present? %>
      flashMessage.innerText = '<%= flash[:notice] %>';
      modalOverlay.style.display = 'block';
  <% end %>

  closeModalButton.addEventListener('click', () => {
    modalOverlay.style.display = 'none';
  });
</script>

app/views/users/_user.html.erb
<div class='col-12'>
  <div class="row">
    <div class="col-2"><%= image_tag user.photo %></div>
    <div class="col-10 user__details p-16">
        <h2 class="user__title"><%= link_to_unless_current user.name, user , class:"user__title-link" %></h2>
        <p class="user__post-count">Number of posts: <%= user.posts.count %> </p>
    </div>
  </div>
</div>

app/views/users/index.html.erb
<div class="container my--16">
  <div class="row">
    <% if @users.empty? %>
      <p>No user found!</p>
    <% else %>
        <% @users.each do |user| %>
            <%= render user %>
        <% end %>
    <% end %>
  </div>
</div>

app/views/users/shared/_error_messages.html.erb
<% if resource.errors.any? %>
  <div id="error_explanation" data-turbo-cache="false">
    <h2>
      <%= I18n.t("errors.messages.not_saved",
                 count: resource.errors.count,
                 resource: resource.class.model_name.human.downcase)
       %>
    </h2>
    <ul>
      <% resource.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
  </div>
<% end %>

app/views/users/shared/_links.html.erb
<div class="form__links font-sm text-center">
<%- if controller_name != 'sessions' %>
  Aready have an account? Go to <%= link_to "Log in", new_session_path(resource_name) %> page.<br />
<% end %>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
 Are you new here? <%= link_to "Sign up", new_registration_path(resource_name) %> to create an account.<br />
<% end %>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  Forgot your password? <%= link_to "Click here", new_password_path(resource_name) %> to get reset email .<br />
<% end %>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= button_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider), data: { turbo: false } %><br />
  <% end %>
<% end %>
</div>

app/views/users/show.html.erb
<div class="container my--16">
  <div class="row">
    <%= render @user %>
    <div class="col-12 user__bio p-16">
      <h2>Bio</h2>
      <p><%= @user.bio %></p>
    </div>
  </div>
  <div class="row user__posts">
      <div class="col-6">
      <h3 class="post__list-title">All Posts</h3>
    </div>
    <div class="col-6">
      <div class="post__btn-wrapper-r">
        <button class="btn btn--primary btn__add-new" >Add New Post</button>
      </div>
    </div>
    <% if @user.recent_posts.empty? %>
     <div class="col-12 p-16 user__post">
        <p>No post found!</p>
      </div>
    <% else %>
        <% @user.recent_posts.each do |post| %>
          <%= render post %>
        <% end %>
         <div class="col-12 user__btn-wrapper">
         <%= link_to "See all posts", user_posts_path(@user), class: "btn btn--primary" %>
         </div>
    <% end %>
  </div>
</div>

<script>
  var button = document.querySelector('.btn__add-new');
  button.addEventListener('click', function() {
    window.location.href = '<%= new_user_post_path(@user) %>';
  });
</script>